# Waypoints
Waypoints in Vanilla! Did you ever look at waypoint plugins and mods
and think: "Oh, I'd love to have those as a datapack!" No? Well,
neither have I! Nonetheless I have created this datapack in which I
attempt nothing less than create a fully functional survival
datapack bringing a gameplay side to waypoints.

## So what is this really?
If you don't know what waypoints/warps are: You mark a location in
the world with a name and then you can teleport to it whenever you 
want. Some servers use it to get around faster, even when playing
on an SMP. 

Most of these however, especially plugins, fail to integrate the
feature into gameplay. My take on waypoints tries to do just that:
Implement waypoints in Minecraft Vanilla in a way that it works
cleanly with game and preserves balance.

## How do you set up a waypoint?
Setting up a waypoint is quite easy to do. You require nothing more
than a Book and Quill and an Enderpearl. Throwing these together on
a Crafting Table will give you a new Book and Quill that you can
sign to create a waypoint at your current location. You will receive
a new book detailing your waypoint.

![A Book and Quill and an enderpearl make a waypoint creator](images/crafting_waypoint_creator.png)

## How do you teleport to a waypoint?
Getting a teleport to a waypoint is a little more difficult. In 
fact, it's almost impossible if you don't have a teleport book.

### How do you get a teleport book?
You can craft a teleport book using a Book and Quill and 8 Echo Shards. You will need to throw them on a Crafting Table like with the Waypoint Creator.

![A Book and Quill and eight Echo Shards make a teleport book](images/crafting_teleport.png)

It should be noted that this book will not contain any waypoint by
default, you will have to add them yourself with the books you get
from creating waypoints.

### How do you put waypoints into a teleport book?
This step is quite simple. Adding a waypoint to a teleport book is
done by throwing your teleport book and a waypoint book onto a
Cartography Table. The waypoint book will vanish and you will have
added a new waypoint.

## How do I keep my waypoint books then?
Doing this is astoundingly simple, the game already implemented it
for me, in fact. Just duplicate any of your books (even teleport books!) in a crafting table.


# Project Status
This datapack is currently in **BETA**. This means the pack is
functional for creative as well as survival, but lacks some optional
features. Notably, while the data model supports waypoint
descriptions and level cost for teleport, there is no way to set
these for a waypoint without directly modifying the data.

More features will be added in the future.

## Roadmap
This roadmap shows the features I intend to include in later
versions.

+ ~~Adding waypoint descriptions~~
+ ~~Configuring waypoint cost as an admin~~
+ Advancements for attaining certain items or completing certain
actions.
+ Loadstone-connected waypoints
+ Variable level cost depending on distance? (May be added in the
future, but probably after all the other points.)
+ Better configuration using a chat-based ui
+ Visually show waypoints by means of particles or similar


# Public Servers / Series
If you are reading this section, chances are you want to use my
datapack on a public server or in a YouTube series. Should that be
the case: I feel honoured! You are totally free to do that, but do
make sure, you give me credit (e.g. a video description / a sign at
spawn) and provide some sort of link to this pack's GitHub or Modrinth.
